
-- final tallies
PR.TSRT = 0
PR.TSRU = 0
PR.TSRR = 0
  
-- Results of the audit  [Sector id] = value
PR.SRT = {}  -- total
PR.SRU = {}  -- unknown/unscanned
PR.SRR = {}	-- recorded  


-- I/O Handling
PR.AuditTimer = Timer()
PR.StatisticSpam = 0
PR.AuditSpam = 0

PR.StatInhibit = 0
PR.StatITimer = Timer()

PR.AuditLocation = 0

function PR.AuditSetup()
   if PR.Config.Audit == nil or PR.Config.Audit > 30 then PR.Config.Audit = 0 end
  
   
   PR.SRT = {}
   PR.SRU = {}
   PR.SRR = {}
   
   PR.AuditLocation = 0     -- 1 -> 255 sectors
   PR.AuditStep()
end

function PR.AuditStep()
   if PR.AuditLocation > 16 * 16 then
      -- save system data
      local lsrt = 0
      local lsru = 0
      local lsrr = 0
     
      for index = 1 , 255 do
         local pointer = (index + (PR.Config.Audit * 16 * 16))
         
         local tval = PR.SRT[pointer] or 0
         lsrt = lsrt + tval
         local uval = PR.SRU[pointer] or 0
         lsru = lsru + uval
         local rval = PR.SRR[pointer] or 0
         lsrr = lsrr + rval
      end
      -- Record the results and move to the next system
      PR.Config.Audit = PR.Config.Audit + 1   -- do this first -> no zero in tables
      PR.Config.SRT[PR.Config.Audit] = lsrt
      PR.Config.SRU[PR.Config.Audit] = lsru
      PR.Config.SRR[PR.Config.Audit] = lsrr      

    --  if PR.Config.AuditSysNext < 31 then 
      --   PR.Config.Audit = (PR.Config.AuditSysNext )
     --    PR.Config.AuditSysNext = 100
     -- end
      
      PR.SaveInfo()
      PR.RoidStats()

      PR.AuditTimer:SetTimeout(5000 , PR.AuditSetup)
   else 
      -- at 5 seconds will take 20 minutes per system
      -- at .5 will take 2 minutes per system
      PR.AuditTimer:SetTimeout(3456,PR.AuditSector)   -- used an odd number to keep things from lock step timing
   end
end




function PR.AuditSector()
   local SectorId = PR.AuditLocation + (PR.Config.Audit * 16 * 16)
   PR.AuditLocation = PR.AuditLocation + 1
   
   PR.Audit = {}
   PR.Audit.MaxId = 0
   PR.Audit.Usable = 0
   PR.Audit.RoidStatus = {}
   PR.Audit.RoidList = {}
   PR.Audit.Unscanned = 0
      
   local RoidNotes = LoadSystemNotes(PR.SystemPrefix + SectorId )
   local tempD = unspickle(RoidNotes)
   for Cat,Data in pairs (tempD) do
      PR.Audit[Cat] = tempD[Cat]           
   end 
   local RoidCounter = 0
   if PR.Audit.RoidList ~= nil then               
      for RoidId,Data in pairs (PR.Audit.RoidList) do
         RoidCounter = (RoidCounter +1)
      end
   end
   if PR.Audit.Usable ~= RoidCounter then PR.Audit.Usable = RoidCounter end
 
   PR.Audit.Unscanned = 0
   if PR.Audit.MaxId == nil then
   return 
   end
   for Index = 1 , PR.Audit.MaxId do
      if PR.GetRoidStatus(Index) == "u" then PR.Audit.Unscanned = PR.Audit.Unscanned +1 end
   end

   if PR.Audit.MaxId > 0 then
      PR.SRT[SectorId] =  PR.Audit.MaxId
      PR.SRU[SectorId] =  PR.Audit.Unscanned
      PR.SRR[SectorId] =  PR.Audit.Usable
   end
   
   PR.AuditStep()
end


function PR.RoidStats()
   PR.TSRT = 0
   PR.TSRU = 0
   PR.TSRR = 0
   
   for index = 1 , 30 do
      PR.TSRT = PR.TSRT + (PR.Config.SRT[index] or 0)
      PR.TSRU = PR.TSRU + (PR.Config.SRU[index] or 0)
      PR.TSRR = PR.TSRR + (PR.Config.SRR[index] or 0)
   end      
   
   if PR.Config.Quiet == "NO" and PR.StatInhibit == 0 then
      PR.StatInhibit = 1
      PR.StatITimer:SetTimeout(450000 , PR.StatLoud )
      local nstring = SystemNames[PR.Config.Audit +1] or "error"      
      if nstring == "error" then 
         nstring = tostring(PR.Config.Audit)
         PR.Config.Audit = 0 end

      local wstring = nstring.. " -> Total Roids = ".. PR.TSRT .. " Unscanned = " .. PR.TSRU .. " Recorded = " .. PR.TSRR 
      print("\t\127".. COLOR.HEXGOLD .. wstring .. "\127o")
   end
end

function PR.StatLoud()
   PR.StatInhibit = 0
end
