-- Author PaKettle
-- 13 August 2016

PR.SystemPrefix = 91000000   -- This one is for config  

PR.Config = {}
PR.Config.Version = 2.5                     
PR.Config.MinXPV = 500               -- Minimum value for roid to be considered
PR.Config.DisplaySort = "BySystem"
PR.Config.BestRoid = 0
PR.Config.BestValue = 0
PR.Config.COLOR = "COLOR"            -- or "WHITE" flag for white or color scheme
PR.Config.Quiet = "NO"                -- Controls the printing of some messages   
PR.Config.Platform = "PC"

PR.Config.Audit = 0
PR.Config.AuditSysNext = 100
PR.Config.SRT = {}                -- index is + 1 due to zero issue
PR.Config.SRU = {}
PR.Config.SRR = {}

PR.SpamTime = Timer()
PR.SaveInfoTimer = Timer() 
 
 function PR.SaveInfo()
   if not PR.SaveInfoTimer:IsActive() then
      PR.SaveInfoTimer:SetTimeout(2000000,PR.SaveInfoNow)
   end
 end
    
function PR.SaveInfoNow()
   PR.SaveInfoTimer:Kill()
   local StringNotes = spickle(PR.Config)
   SaveSystemNotes(StringNotes,PR.SystemPrefix)
   print("Saving Configuration")
end   
  

function PR.LoadInfo()
   local platter = {}
   local StringNotes = LoadSystemNotes(PR.SystemPrefix) or {}
   platter = unspickle(StringNotes) or {}
   for Cat,Data in pairs (platter) do
      PR.Config[Cat] = Data
   end 
end   
 

function PR.FormatNumber(NumIn)
   -- Outputs number in the form "00000"
   if NumIn == nil then return end
   local Outstring = "000000" .. tostring(NumIn)
   Outstring = string.sub(Outstring ,-5 ,-1)
   return Outstring
end

function PR.Print(Text)   -- redirects print if docked or in space
   if PR.Config.COLOR == "WHITE" then 
      Text = "\t\127"..COLOR.WHITE .. tostring(Text) .. "\127o"
   else
      Text = "\t\127ff00ff" .. tostring(Text) .. "\127o" 
   end
   if HUD.visible and PR.Config.Platform == "PC" then 
      HUD:PrintSecondaryMsg(Text)    
   else 
      print(Text)
   end
end


function PR.ReminderSpammer()
   if (PlayerInStation()) then return end   -- end of housekeeping

   local spamdeath = 30000    
   if PR.Config.Quiet == "NO" then  spamdeath = 10000 end
   PR.SpamTime:SetTimeout(spamdeath , PR.ReminderSpammer)
      
   if PR.AutoScan == "ON" then  
      local perks = 100 - (math.floor(PR.Data.Unscanned / PR.Data.MaxId * 100))
      local P2string = PR.Data.Unscanned .. " Unscanned of ".. PR.Data.MaxId .. " @ " ..perks .. "% Completion"
      if PR.Data.Unscanned > 0 then PR.Print(P2string) else PR.Print("No unscanned asteroids") end
      PR.Print("Auto Scanning Active - Horizon is " .. PR.ScanHorizon.." meters ") 
       
      if ((PR.ScanSearch == "HARD") or (PR.ScanSearch == "single")) and PR.DearlyDeparted > 0 then 
         PR.Print("Looking for asteroid number .. ".. PR.DearlyDeparted)
      end
   end
   
   if PR.PickAxe ~= "no" and PR.WeighIn ~= "no" and PR.Config.Quiet == "NO" then
      if PR.MassCounter == 0 then
         PR.Print("Ready to conduct asteroid mass measurement")
      else      
         PR.Print("Mass test in progress " .. PR.MassCounter .. " of ".. PR.MassCountTarget .. " samples completed")
      end
   end
end


