-- author PaKettle@Ymail.com
-- Jan 2018


PR.Config.Search = {}
PR.Config.Search.Ore = "He"
PR.Config.Search.Area = "Serco"
PR.Config.Search.System = 1

           
function PR.RefreshHuntBox()
   local Index = 1
   PR.DisplayPanel[Index] = "\t\127".. COLOR.HEXBLUE .. "No Known Asteroids" 
   local sysnum = PR.Config.Search.System
   local sysname = SystemNames[sysnum]      
   local RoidNotes = LoadSystemNotes(PR.SystemPrefix + 10000 + sysnum )
   local SystemData = unspickle(RoidNotes)
      
   local systable = SystemData[PR.Config.Search.Ore]
   local LongOre = ""
   for longore,shortore in pairs (Tbl.OreBrev) do  
      if shortore ==  PR.Config.Search.Ore then LongOre = longore end
   end
   
   
   local GoodStuff = ""    
   if systable ~= nil then
      for sid , source in pairs (systable) do
         if source == nil then source = "" end
         if source == 1 or "L"then GoodStuff = "L" end
         if GoodStuff ~= "" then
            PR.DisplayPanel[Index] = "\t\127".. COLOR.HEXBLUE .. LocationStr(sid)
            Index = Index + 1
         end  
      end
   end  
   PR.MaxDisplayedRoids = Index 
end


function PR.FetchNextSystem()
   local sysid = PR.Config.Search.System or 0
   local area = "G"
   if PR.Config.Search.Area == "Serco" then area = "S" end
   if PR.Config.Search.Area == "Itani" then area = "I" end
   if PR.Config.Search.Area == "UIT" then area = "U" end
   
   repeat
      sysid = sysid + 1
      if sysid > 30 then sysid = 0 end
   until Tbl.SysOwn[sysid] == area 
   PR.Config.Search.System = sysid
end


function PR.ChangeType()

   if PR.gooeymode == "V" then
      if PR.Config.DisplaySort == "ByOre" then PR.Config.DisplaySort = "BySystem"
      elseif  PR.Config.DisplaySort == "BySystem" then PR.Config.DisplaySort = "Missing"
      else PR.Config.DisplaySort = "ByOre"
      end
   end
   
   if PR.gooeymode == "H" then
      -- not gonna allow search for lesser ores
      -- ["He"] = 20,["Pe"] = 18,["De"] = 15,["Ap"] = 14, ["Py"] = 12,["La"] = 10,["Xi"] = 8, ["Va"] = 7, ["Is"] = 6
      
      if PR.Config.Search.Ore == "He" then PR.Config.Search.Ore = "Pe" 
      elseif PR.Config.Search.Ore == "Pe" then PR.Config.Search.Ore = "De"
      elseif PR.Config.Search.Ore == "De" then PR.Config.Search.Ore = "Ap"
      elseif PR.Config.Search.Ore == "Ap" then PR.Config.Search.Ore = "Py"
      elseif PR.Config.Search.Ore == "Py" then PR.Config.Search.Ore = "La"
      elseif PR.Config.Search.Ore == "La" then PR.Config.Search.Ore = "Xi"
      elseif PR.Config.Search.Ore == "Xi" then PR.Config.Search.Ore = "Va"
      elseif PR.Config.Search.Ore == "Va" then PR.Config.Search.Ore = "Is"
      else PR.Config.Search.Ore = "He" end   
   
   end
   
   if PR.gooeymode == "L" then
      if PR.Config.DisplaySort == "ByRoidId" then PR.Config.DisplaySort = "ByXPV"
      elseif PR.Config.DisplaySort == "ByXPV" then PR.Config.DisplaySort = "ByMass"
      elseif PR.Config.DisplaySort == "ByMass" then PR.Config.DisplaySort = "ByValue"
      else PR.Config.DisplaySort = "ByRoidId" end
      
   end
  

   if PR.gooeymode == "C" then
      if PR.Config.Platform == "PC" then
         PR.Config.Platform = "GO"
      else
         PR.Config.Platform = "PC"
      end
   end
end
