-- author PaKettle@Ymail.com
-- Jan 2018
   
-- may decide to add a missing roid by id number????

PR.DisOrder = {}

function PR.RefreshLocalBox()
   if  PR.Config.DisplaySort == nil then PR.Config.DisplaySort = "ByValue" end
   if PR.Display.RoidList == nil then return end

   if PR.Config.DisplaySort == "ByRoidId" then PR.GetRoidsbyNumber() end
   if PR.Config.DisplaySort == "ByXPV"   then PR.GetRoidsbyXPV()   end
   if PR.Config.DisplaySort == "ByMass"  then PR.GetRoidsbyMass()  end
   if PR.Config.DisplaySort == "ByValue" then PR.GetRoidsbyValue() end

end


function PR.GetRoidsbyNumber()
   local Index = 1
   if PR.Display.MaxId == nil then PR.Display.MaxId = 1 end
   for RoidId = 1 , PR.Display.MaxId do
   local RoidTable = PR.Display.RoidList[RoidId]
      if RoidTable ~= nil then 
         if RoidTable["XPV"] ~= nil then
            local Rstring = PR.FormatRoidId(RoidId) .. " , " .. PR.OreString(RoidTable) 
            PR.DisplayPanel[Index] = Rstring  
            PR.DisOrder[Index] = RoidId
            Index = Index + 1  
         end   
      end  
      PR.MaxDisplayRows = Index                     
   end           
end

function PR.GetRoidsbyValue()
   local MaxVal = 0
   local MinVal = 10000
   local Index = 1
   local pak = {}
   PR.DisOrder = {}
   for RoidId,RoidData in pairs(PR.Display.RoidList) do
      local mass = RoidData["Pt"]
      local XPV = RoidData["XPV"]
      if mass == nil then mass = 1 end
      if XPV ~= nil then
         local GVal = math.floor(mass + XPV)
         --local GVal = math.floor(mass * XPV)
         repeat GVal = GVal + 1 until pak[GVal] == nil
         pak[GVal] = RoidId
         if GVal > MaxVal then MaxVal = GVal end
         if GVal < MinVal then MinVal = GVal end
      end
   end
   local Index = 1
   for Counter = MaxVal,MinVal , -1  do               -- step backwards please
      local Tid = pak[Counter]
      if Tid ~= nil then     -- skip the empties
         local RoidData = PR.Display.RoidList[Tid] 
         local Source = RoidData["Src"]                   
         local Rstring = PR.FormatRoidId(Tid,Source) .. " , " .. PR.OreString(RoidData)
         Rstring = Rstring .. " - Gross Value = " .. Counter 
         PR.DisplayPanel[Index] = Rstring
         PR.DisOrder[Index] = Tid
         Index = Index +1
      end
   end
   PR.MaxDisplayedRoids = Index 
end

function PR.GetRoidsbyXPV()
   local MaxXPV = 0
   local MinXPV = 10000
   local Index = 1
   local pak = {}
   PR.DisOrder = {}
   for RoidId,RoidData in pairs(PR.Display.RoidList) do
      if RoidData["XPV"] ~= nil then
         local XPV = math.floor(RoidData["XPV"])
         repeat XPV = XPV + 1 until pak[XPV] == nil
         pak[XPV] = RoidId
         if XPV > MaxXPV then MaxXPV = XPV end
         if XPV < MinXPV then MinXPV = XPV end
      end
   end
   local Index = 1
   for Counter = MaxXPV,MinXPV , -1  do               -- step backwards please
      local Tid = pak[Counter]
      if Tid ~= nil then                    -- skip the empties
         local RoidData = PR.Display.RoidList[Tid]
         local Rstring = PR.FormatRoidId(Tid,"L") .. " , " .. PR.OreString(RoidData)
         local mass = RoidData["Pt"]
         if mass == nil then mass = 1 end
         local GVal = mass * Counter
         Rstring = Rstring .. " - XPV = " .. Counter
         PR.DisplayPanel[Index] = Rstring
         PR.DisOrder[Index] = Tid
         Index = Index +1
      end
   end
   PR.MaxDisplayedRoids = Index 
end

function PR.GetRoidsbyMass()
   local Maxmass = 0
   local Minmass = 9999999
   local pak = {}
   
   for RoidId,RoidData in pairs(PR.Display.RoidList) do
      local mass = RoidData["Pt"]
      if mass == nil then mass = 1 end
      if RoidData["XPV"] ~= nil then
         local mass = math.floor(mass)
         repeat mass = mass + 1 until pak[mass] == nil
         pak[mass] = RoidId
         if mass > Maxmass then Maxmass = mass end
         if mass < Minmass then Minmass = mass end
      end
   end

   local Index = 1
   for Counter = Maxmass,Minmass , -1  do               -- step backwards please
      local Tid = pak[Counter]
      if Tid ~= nil then                    -- skip the empties
         local RoidData = PR.Display.RoidList[Tid]
         local Source = RoidData["Src"]
         local Rstring = PR.FormatRoidId(Tid,Source) .. " , " .. PR.OreString(RoidData)
         Rstring = Rstring .. " - Mass = " .. Counter
         PR.DisplayPanel[Index] = Rstring
         PR.DisOrder[Index] = Tid
         Index = Index +1
      end
   end
   PR.MaxDisplayedRoids = Index 
end

