-- author PaKettle@ymail.com
-- Jan 2018

dofile("GUI/MainPanel.lua")
dofile("GUI/VerseBox.lua")
dofile("GUI/HuntBox.lua")
dofile("GUI/LocalBox.lua")
dofile("GUI/ConfigBox.lua")




PR.gooeymode = "V"        -- Verse System Local
PR.MaxDisplayRows = 0


function PR.Refresher()
   for index = 1, PR.MaxDisplayRows do PR.DisplayPanel[index] = nil end
   PR.DisplayPanel[1] = "No Data Availible"
   PR.MaxDisplayRows = 1
   PR.DisOrder = {}
   
   PR.ModeButton.title = ""   
   PR.TypeButton.title = ""   
   PR.AreaButton.title = ""
   PR.LocaleButton.title = ""
   PR.EditBox.value = ""
      
   local RoidNotes = LoadSystemNotes( PR.SystemPrefix + (GetCurrentSectorid() or 1) )
   if RoidNotes ~= nil then PR.Display = unspickle(RoidNotes)  end


   if PR.Config.DisplaySort == "ByOre" then PR.TypeButton.title = "ByOre" end
   if PR.Config.DisplaySort == "BySystem" then PR.TypeButton.title = "BySystem" end
   if PR.Config.DisplaySort == "Missing" then PR.TypeButton.title = "Missing" end
   if PR.Config.DisplaySort == "ByRoidId" then PR.TypeButton.title = "ByID" end
   if PR.Config.DisplaySort == "ByXPV" then PR.TypeButton.title = "ByXPV" end
   if PR.Config.DisplaySort == "ByMass" then PR.TypeButton.title = "ByMass" end
   if PR.Config.DisplaySort == "ByValue" then PR.TypeButton.title = "ByValue" end
       

   if PR.gooeymode == "V" then
      PR.ModeButton.title = "Verse"
      PR.RefreshVerseBox()      

   elseif PR.gooeymode == "L" then 
      PR.ModeButton.title = "Local"
      PR.RefreshLocalBox()
         
   elseif PR.gooeymode == "H" then 
      PR.ModeButton.title = "Search"
      for longore,shortore in pairs (Tbl.OreBrev) do  
          if shortore ==  PR.Config.Search.Ore then PR.TypeButton.title = longore end
      end
      PR.AreaButton.title = PR.Config.Search.Area       
      PR.LocaleButton.title = SystemNames[PR.Config.Search.System]       
      PR.RefreshHuntBox()
      
   elseif PR.gooeymode == "C" then  
      PR.ModeButton.title = "Config"
      -- buttons are handled in configbox routine
      PR.RefreshConfigBox()
   end
end



   PR.MainDialog = iup.dialog {
      title = PR.FanFare , 
      size = "halfxhalf",
      topmost = "YES", 
      defaultesc = PR.CloseButton,
      iup.vbox {
         PR.HeadBox,
         PR.DisplayPanel,
         PR.TailBox, 
         }   
      }



function PR.ProspecterCommand()
   if PR.Sector ~= 0 and PR.SaveSectorSave > 0 then					
      PR.SaveSectorNow(PR.Sector)
   end

   ShowDialog(PR.MainDialog)
   PR.Refresher()
end

RegisterUserCommand('pr',PR.ProspecterCommand)
RegisterUserCommand('ore',PR.ProspecterCommand)
