-- author PaKettle@Ymail.com
-- Jan 2018

PR.ModeButton = iup.button{
   title = "Mode",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.ModeButton:action()

   if PR.gooeymode == "V" then PR.gooeymode = "L"
   elseif PR.gooeymode == "L" then PR.gooeymode = "H"
   elseif PR.gooeymode == "H" then PR.gooeymode = "C"
   elseif PR.gooeymode == "C" then PR.gooeymode = "V" end
   PR.ChangeType()
   PR.Refresher()
end 




PR.TypeButton = iup.button{
   title = "Type",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.TypeButton:action()
   PR.ChangeType()
  
   PR.Refresher()
end 


PR.AreaButton = iup.button{
   title = " Area ",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.AreaButton:action()

   if PR.gooeymode == "H" then
      if PR.Config.Search.Area == "Serco" then PR.Config.Search.Area = "Itani" 
      elseif PR.Config.Search.Area == "Itani" then PR.Config.Search.Area = "UIT" 
      elseif PR.Config.Search.Area == "UIT" then PR.Config.Search.Area = "Gray"
      else PR.Config.Search.Area = "Serco"  end
      PR.FetchNextSystem()
   end

   if PR.gooeymode == "C" then
      if PR.Config.COLOR == "COLOR" then 
         PR.Config.COLOR = "WHITE"
         PR.AreaButton.title = "WHITE"
      else
         PR.Config.COLOR = "COLOR"
         PR.AreaButton.title = "COLOR"
      end
      PR.ColorChange()
   end

   PR.Refresher()
end 





PR.LocaleButton = iup.button{
   title = " Locale ",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.LocaleButton:action()
   if PR.gooeymode == "H" then
      PR.FetchNextSystem()
   end
   
   if PR.gooeymode == "C" then 
      if PR.Config.Quiet == "NO" then
         PR.Config.Quiet = "YES"
      else
         PR.Config.Quiet = "NO"
      end      
   end
   PR.Refresher()
end 



PR.EditBox = iup.text{
   bgcolor = COLOR.TEAL,
   fgcolor = COLOR.DGREY,
   expand = "HORIZONTAL",
}

function PR.EditBox:action(text,item,state) 
--elem:action(text: string, item, state: number)
-- state appears to be always nil
-- text = last char typed
-- item is current value of box

   print("text =" .. text .. " item =" .. item )
   if PR.gooeymode == "C" and text == 13 then 
      PR.Config.MinXPV = tonumber(item)   
      PR.Refresher()
   end
end



PR.HeadBox = iup.hbox{
   PR.ModeButton,
   PR.TypeButton,
   PR.AreaButton,
   PR.LocaleButton,
   PR.EditBox,
   bgcolor = COLOR.TEAL,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}




PR.DisplayPanel = iup.list{
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "YES",
}
 

function PR.DisplayPanel:action(text,item,state)
   if PR.gooeymode == "L" then
      local RoidId = item
      local RoidId = PR.DisOrder[item]
      -- PR.DisplayRoidSelection = RoidId
      if PR.gooeymode == "L" then PR.FinderOuter(RoidId) end
   end
end




PR.CloseButton = iup.button{
   title = "Close",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.CloseButton:action()
    HideDialog(PR.MainDialog)
end 


PR.SaveButton = iup.button{
   title = "Save",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.SaveButton:action()
   PR.Refresher()
end 

PR.DeleteButton = iup.button{
   title = "Delete",
   bgcolor = COLOR.GRAY,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
}

function PR.DeleteButton:action()
   PR.Refresher()
end 


PR.TailBox = iup.hbox{
   bgcolor = COLOR.TEAL,
   fgcolor = COLOR.BLUE,
   expand = "HORIZONTAL",
   
   PR.SaveButton,
   PR.CloseButton,
   PR.DeleteButton,

}






