-- Author PaKettle
-- March 2017

-- These maybe changed to reflect the config to white only
PR.ColorRed = COLOR.HEXRED         
PR.ColorBlue = COLOR.HEXBLUE
PR.ColorPurple = COLOR.HEXPURPLE
PR.LastPrintRid = 0


function PR.ColorChange()
   if PR.Config.COLOR == "WHITE" then
      PR.ColorRed = COLOR.HEXWHITE
      PR.ColorBlue = COLOR.HEXWHITE
      PR.ColorPurple = COLOR.HEXWHITE
   else
      PR.ColorRed = COLOR.HEXRED 
      PR.ColorBlue = COLOR.HEXBLUE
      PR.ColorPurple = COLOR.HEXPURPLE
   end
end

function PR.FormatRoidId(NumIn)
   -- Outputs roid number in the form "#00000"
   if NumIn == nil then return end
   local outstring = "000000" .. tostring(NumIn)
   outstring = "#".. string.sub(outstring ,-5 ,-1)
   return outstring
end


function PR.DisplayScanData(RoidTable)
   local SectorId = RoidTable["Sid"]    
   local RoidId = RoidTable["Id"]
   
   if PR.Config.Quiet == "NO" and RoidId ~= PR.LastPrintRid then    
      PR.LastPrintRid = RoidId
      local pstring = "\127"..COLOR.HEXGOLD.."Asteroid " .. PR.FormatRoidId(RoidId) .." "
      local dist= math.floor(tonumber(GetTargetDistance() or 0 ))
      local oremem = PR.GetRoidStatus(RoidId)
      if oremem == "j" then pstring = pstring .. "is Junk @ Range = " .. dist .. "\127o" end    
      if oremem == "u" then pstring = pstring .. "is UnKnown @ Range = " .. dist .. "\127o" end   
      if oremem == "r" then 
         local displaystring = PR.OreString(RoidTable)
         local mass = RoidTable["Pt"] or 0
         local XPV = RoidTable["XPV"] or 0
         pstring = pstring .. displaystring .."\127"..COLOR.HEXGOLD .. " ->  Mass = " .. mass .." Petagrams - XPV = ".. XPV .. "\127o"
         print(pstring)
      else
         PR.Print(pstring)
      end       
   end   
end


function PR.OreString(RoidTable)
   local dstring = " "
   for ore,cval in pairs (Tbl.OreColor ) do  
      if PR.Config.COLOR == "WHITE" then  cval = COLOR.HEXWHITE end   -- change to white
      local tval = RoidTable[ore] or 0
      if tval > 0 then  dstring = dstring .." \127".. cval ..ore .." = "..  tval .. " \127o"  end               
   end
   return(dstring)      
end






