
-- Author PaKettle Aug 2016
-- radar.SetRadarSelectionByPoint(0.3837, 0.9927, "RadarNextFront")
-- http://www.vo-wiki.com/racecar2/index.php?title=Radar

PR.ScanRange = 0
PR.BeamAvgHeat = 0          -- Avg Heat rate of beams
PR.AutoScan = "off"        -- "ON" or "off"
PR.ScanHorizon = 1000000
PR.ScannerEquipped = "no"
PR.PickAxe = "no"
PR.ScanSearch = "soft"
PR.DearlyDeparted = 0


function PR.RoidLocator()
   if PR.ScanSearch == "single" then 
      PR.Timer:SetTimeout(10000 ,PR.RoidLocator )
      radar.SetRadarSelection(2,PR.DearlyDeparted)
   end
    
   local dist=GetTargetDistance() 
    
   if dist == nil then dist = 999999999 end
   if dist < 500 then 
      PR.ScanSearch = "soft"
      PR.DearlyDeparted = 0 
   end
end

function PR.FinderOuter(RoidId)
   PR.DearlyDeparted = RoidId
   PR.ScanSearch = "single"
   PR.RoidLocator()
end

function PR.ScannerOffSwitch()
   if PR.AutoScan == "ON" then PR.Print("Turning AutoScanning off") end
   PR.AutoScan = "off"
   PR.ScanSearch = "off"
   PR.DearlyDeparted = 0
   PR.WeighIn = "no"
   -- gkinterface.GKProcessCommand('RadarNone')          -- force radar to abort scan
end

function PR.RoidScanner()
   PR.GetRange()
   
   if PR.AutoScan == "ON" or PR.ScannerEquipped ~= "YES" or (PR.Data.Unscanned == 0 and PR.Data.MaxId > 0) then 
      PR.ScannerOffSwitch() 
      return 
   end
         
   if PR.Status ~= "READY" then
      PR.Print("Prospector is not ready yet")
      return
   end
   
   if PR.Levi > 0 then
      print("\t\127"..COLOR.HEXRED.."Scanning Inhibitted due to Hive intrusion" .. "\127o")
      return
   end
   
   PR.ScanHorizon = PR.ScanRange + (PR.ScanRange * PR.ScanCompletion)
   local MaxRange = GetMaxRadarDistance()
   if PR.ScanHorizon > MaxRange then PR.ScanHorizon = MaxRange end

   if PR.Data.Unscanned == nil then PR.Data.Unscanned = 0 end
   if PR.Data.MaxId == nil then PR.Data.MaxId = 0 end

   RegisterEvent(PR.TargetScanned,"TARGET_SCANNED" )
   gkinterface.GKProcessCommand('RadarNone')
   PR.AutoScan = "ON"      
   PR.ReminderSpammer()
   PR.DelayedScan()
end

RegisterUserCommand('rs',PR.RoidScanner)   
RegisterUserCommand('roidscan',PR.RoidScanner)


function PR.DelayedScan()
   if PR.AutoScan == "ON" then 
      local target = PR.RoidPrep()
      -- need to handle case where no roid is in range here
      radar.SetRadarSelection(2,target)
   end
end

function PR.RoidPrep()
   local closeroid = 0
   local closerange = 99999999
   local hemiroid = 250  -- default search for new roids
   if PR.Data.MaxId > 0 then hemiroid = PR.Data.MaxId + 10 end
        
   for target=1, hemiroid do
      local dist = 999999999
      local oremem = PR.GetRoidStatus(target) 
      if oremem == "u" then 
         if PR.Targetless then  targetless.api.radarlock = true end
         
         radar.SetRadarSelection(2,target)
         local loopcount = 0
         repeat
            loopcount = loopcount +1
            local nid , rfid = radar.GetRadarSelectionID() 

         until ( rfid == target or loopcount > 10 or nid ~= 2 )
         dist = math.ceil(GetTargetDistance() or 0)
         
         if PR.Targetless then targetless.api.radarlock = false end

         if loopcount < 10 then
            local name = GetTargetInfo()
            if (name=='Asteroid' or name=='Ice Crystal') then 
               if (target > PR.Data.MaxId) and (dist > 20)  and (dist < 5000) then 
                  PR.UpdateRoidStatus(target,"u") 
                  if PR.Config.Quiet == "NO" then PR.Print("Asteroid #"..target .. " located at " .. dist .. " meters") end 
                  if  dist < PR.ScanHorizon then return (target)  end
               end    
               if dist < closerange then 
                  closeroid = target 
                  closerange = dist
              end
            end
         end 
      end
   end
   return (closeroid)
end



function PR.GetRange()
   local beamqty = 0
   local totalheat = 0
   local hottie = 0
   PR.BeamAvgHeat = 0
   PR.ScannerEquipped = "no"
   PR.PickAxe = "no"
   for _ , itemid in ipairs(GetShipInventory(GetActiveShipID()).addons) do
      local item_name = GetInventoryItemName(itemid)
      if item_name:find'Mining Beam' then 
         PR.PickAxe = "YES" 
         beamqty = beamqty + 1
         local bscript = GetInventoryItemLongDesc(itemid)
         local tween = string.match( bscript,'Heat: (.-)|' )
         local twang = string.sub(tween,1,3)
         
         if tween ~= nil then hottie = tonumber(twang) * 100  end
         totalheat = totalheat + hottie
      end

      if Tbl.Scanners[item_name] then 
         PR.ScannerEquipped = "YES"
         PR.ScanRange = Tbl.Scanners[item_name]
      end
   end

   if beamqty > 0 then PR.BeamAvgHeat = totalheat / beamqty  end
   if PR.ScanRange == nil then PR.ScanRange = 0 end
   -- need to see if the ship has a built in scanner as well
   local shipname = GetActiveShipName()
   if Tbl.ShipsWithScan[shipname] then 
      PR.ScannerEquipped = "YES"
      PR.ScanRange = Tbl.ShipsWithScan[shipname]
   end
end
