-- Author PaKettle@Ymail.com
-- re-write Nov 2016

PR.TargetScanned = {}     -- init in main        
PR.MassTarget = 0
PR.WeighIn = "no"
PR.MassCounter = 0
PR.MassCountTarget = 0
PR.LastTemp = 0

function PR.TargetScanned (event, scaninfo, Node , objectid)
   if scaninfo == nil or Node == nil or objectid == nil then return end  -- precautions to prevent nil errors

   local name = GetTargetInfo()
   if not (name=='Asteroid' or name=='Ice Crystal') then 
      if PR.AutoScan ~= "off" then PR.DelayedScan() else return  end
   end
   
   if PR.Targetless then targetless.api.radarlock = false end 
   if objectid == PR.DearlyDeparted then PR.ScanSearch = "off" end       -- object has been found
   
   local SectorId = GetCurrentSectorid()
   local ScanData = scaninfo
   local RoidTable = {["Pt"] = 0,["Sid"] = SectorId ,["Id"] = objectid}
   
   local temp = tonumber(string.match(ScanData ,'Temperature: (.-) K' ))  -- temp must be a number!
   
   if PR.WeighIn == "YES" then   
      if PR.MassCounter > 0 and (objectid ~= PR.MassTarget or not(temp > PR.LastTemp)) then 
         PR.MassCounter = 0
         PR.WeighIn = "no" 
         if temp > 10 and PR.Config.Quiet == "NO" then PR.Print("Mass Measurement test failure") end
      end   -- unset roid mass measurement

      if temp > 10 then
         PR.LastTemp = temp
         PR.MassCounter = PR.MassCounter +1
         local maxcargo = GetActiveShipMaxCargo()
         PR.MassCountTarget = 5
         if maxcargo > 100 then PR.MassCountTarget = 10 end
      
         if PR.MassCounter > (PR.MassCountTarget -1) then
            PR.MassCounter = 0 
            local tempdiff = (temp - 10)
            local mass = math.floor((PR.MassCountTarget/tempdiff) * PR.BeamAvgHeat)
            PR.UpdateRoidMass(objectid,mass)
            print("Roid Mass determined to be " .. mass .." Petagrams")
            PR.WeighIn = "no"
         end
      end   -- if temp > 10
   end   -- if weigh in = yes
   
   if temp == 10 and PR.PickAxe ~= "no" then 
      if PR.GetRoidStatus(objectid) == "r" then 
         PR.WeighIn = "YES"
         PR.LastTemp = temp
         PR.MassTarget = objectid
      else 
         PR.WeighIn = "no"         
      end 
      PR.MassCounter = 0
   end

   if PR.ScannerEquipped == "no" then 
      PR.CheckDataBase(RoidTable)   
   else
      if string.find(ScanData,'Object too far' ) ~= nil then                   
         PR.CheckDataBase(RoidTable)
      else   
         for line in string.gmatch(ScanData, '(.-)\n') do  
            local Lore, density  = string.match(line ,'(%w+) Ore: (.+)%%') 
            if density == nil then density = 0 end
            if Lore == nil then Lore = "" end
            local percent =  tonumber(density)
            local ore = Tbl.OreBrev[Lore]
            if ore ~= nil then RoidTable[ore] = percent end  
         end
         PR.ProcessRoid(RoidTable)
      end    -- if too far
   end       -- if scanner
end
        
function PR.ProcessRoid(RoidTable)
   local SectorId = RoidTable["Sid"] or 0  
   local RoidId = RoidTable["Id"] or 0
   local HoldTimer = Timer()
   local HangTime = 1
   
   RoidTable["XPV"] = 0
   
   for oretype , orevalue in pairs (Tbl.Ore) do
      local percent = RoidTable[oretype] or 0
      RoidTable["XPV"] = RoidTable["XPV"] + (percent * orevalue ) 
   end  
   local oremem = PR.GetRoidStatus(RoidId) or "u"
   
   PR.SectorDataCollection(RoidTable)       -- systemdata.lua
   
   if RoidTable["XPV"] > PR.Config.MinXPV then 
      PR.Data.Usable = (PR.Data.Usable + 1) 
      PR.SetRoid(RoidTable)
      PR.UpdateRoidStatus(RoidId,"r")       -- set roid to recorded 
      HangTime =  RoidTable["XPV"] * 2
          
   else
      PR.UpdateRoidStatus(RoidId,"j")       -- set roid to scanned
      HangTime = 50
   end
   PR.DisplayScanData(RoidTable)  
   RoidTable["Sid"]= SectorId               -- was altered by set roid
   RoidTable["Id"] = RoidId

   HoldTimer:SetTimeout(HangTime , PR.DelayedScan)
end

function PR.CheckDataBase(RoidTable)
   local SectorId = RoidTable["Sid"]
   local RoidId = RoidTable["Id"]
   if SectorId == nil or SectorId == 0 or RoidId == nil or RoidId == 0 then return end

   local dist = GetTargetDistance()
   if dist == nil then return end
   
   local HoldTimer = Timer()
   local HangTime = math.floor( (10000 - dist) * 100 ) 
   
   local oremem = PR.GetRoidStatus(RoidTable["Id"])    
   if  oremem == "r" then RoidTable = PR.GetRoid(SectorId,RoidId )  end
   PR.DisplayScanData(RoidTable)
   if oremem == "u" then 
      if dist < PR.ScanHorizon then HangTime = 60000 end
      if PR.ScanSearch == "HARD" then HangTime = HangTime * 2 end
   end

   HoldTimer:SetTimeout(HangTime , PR.DelayedScan)
end


