-- Prospector By PaKettle
-- 13 August 2016
-- Plugin to Record Asteroid data
-- http://www.vo-wiki.com/wiki/Mining#List_of_Ores

-- commands 
-- ore        - display roid data
-- prconfig   - shows configuration screen
-- rs         - roid scan  

PR = {}
PR.Init = {}
PR.SectorChange = {}             
PR.Sector = 0                 -- current sector
PR.System = 0                 -- current system
PR.Targetless = false
PR.Status = "Loading"
PR.Timer = Timer()
PR.FanFare = "Prospector Version 2.5 "
PR.Levi = 0

dofile("Tables.lua")            
dofile("Facility.lua")
dofile("Audit.lua")
dofile("RoidData.lua")
dofile("RoidDisplay.lua")
dofile("RoidScan2.lua")
dofile("ScanEvent.lua")
dofile("SystemData.lua")
dofile("SystemScan.lua")		-- scan system for bots
dofile("GUI/MainGUI.lua")




function PR.SectorChange()                   --  Sync routine for each jump....
   -- first cleanup any left overs
   if PR.Sector ~= 0 and PR.SaveSectorSave > 0 then					
      PR.SaveSectorNow(PR.Sector)
   end
   
   PR.ScannerOffSwitch()
   PR.Sector = GetCurrentSectorid() 
   if PR.System ~= GetSystemID(PR.Sector) then
      PR.System = GetSystemID(PR.Sector)
   end

   -- only if we are mining equipped
   if PR.PickAxe == "YES" or PR.ScannerEquipped == "YES" then
      PR.LoadSector(PR.Sector)               
      PR.GetRange()                              -- check for mining equipment
      PR.EntryScan()                           -- check roids,bots or levi present
      PR.RoidStats() 
      PR.ReminderSpammer()    
      PR.Levi = 0
      PR.LeviDelayCount = 0
   end
end

RegisterEvent(PR.SectorChange , "SECTOR_CHANGED")

function PR.Init()
   PR.LoadInfo()
   UnregisterEvent(PR.Init, "SHOW_STATION") 
   UnregisterEvent(PR.Init, "HUD_SHOW")
   PR.Sector = GetCurrentSectorid()   
   PR.System = GetSystemID(PR.Sector)
   
   if (PR.Sector == nil or PR.Sector == 0) then
      PR.Timer:SetTimeout(5000,PR.Init)
      return
   end
   
   PR.AuditSetup()
   PR.LoadSector(PR.Sector)
   PR.GetRange() 
   PR.Timer:SetTimeout(5000,PR.Registration )
   PR.Targetless = pcall(function() return targetless.api end)  
end

RegisterEvent(PR.Init, "SHOW_STATION") 
RegisterEvent(PR.Init, "HUD_SHOW") 

function PR.Registration()
   RegisterEvent(PR.SectorChange, "HUD_SHOW")
   RegisterEvent(PR.TargetScanned,"TARGET_SCANNED" )     -- scanevent.lua
   PR.Status = "READY"
   print(PR.FanFare)
end 

function PR.LastRites()
   -- quick save to prevent loss of data when logging etc
   if PR.SaveSectorSave > 0 then PR.SaveSectorNow(PR.Sector) end
   if PR.SaveInfoTimer:IsActive() then PR.SaveInfoNow() end
end

RegisterEvent(PR.LastRites , "PLAYER_LOGGED_OUT")
RegisterEvent(PR.LastRites , "PLAYER_DIED")
